
			     BZFlag release notes

* add new updates here without heading until a release

BZFlag 1.7g0 "Holy Dancing Monkeys" (was 1.7e7)
-------------------------------------------------------

* -tkkr auto team killer - Dave Brosius
* world file caching - Colin Bayer, Dave Brosius, others
* optional tank labels for roaming - Frank Thilo, Tim Riker
* draw tank lights correctly for (T)(N)(O) tanks - Dave Brosius
* new GUI options menu - Frank Thilo
* exclude observers from /idlestats list - Frank Thilo
* server based scoring - Dave Brosius, Tim Riker
* max. number of observers now defaults to 3 instead of 0 - Frank Thilo
* Use high water marks for player cnts to reduce looping - Dave Brosius
* new bzfs option -tk: team killers do not die - Frank Thilo
* misc @observer mode fixes - Andrew Greig
* Improved Mac OS X support - Kevin Avila
* disallow dud flags (eg jump in a jump world) - Dave Brosius
* self destruct key, for stuck tanks - Dave Brosius
* team killers die - Tim Riker
* increase max player and robot counts - Tim Riker
* Fix 'Change Key Mapping' arrowkeys - Andrew Greig 
* show the time in upper right if no flag
* opacity in config - Dave Brosius, Tim Riker
* [UN]SILENCE - Dave Brosius, Tim Riker
* revert lag falling patch - Tim Riker, Dave Brosius
* teamgrab.wav - Dave Brosius
* improved texture mapping - unknown
* possible win32 installer bug - Chris Walters
* gcc 3.1+ patches - David Trowbridge

BZFlag 1.7e6 or Armoured Smashing Fist 2002 (was 1.7e5)
-------------------------------------------------------

* new HUD! - David Trowbridge, Tim Riker, many others
* added temporary bans (minutes) - Dave Brosius
* Can now build entire win32 installer from VC Workspace - Dave Brosius
* non-listserver connection gave 0.0.0.0 as host: fixed - Dave Brosius
* added private messages - Frank Thilo
* modified / added roaming support for observers - Frank Thilo
* added /idlekick server option - Frank Thilo
* fix /ban and add /unban - Frank Thilo
* allow both -mp # and -mp #,#,#,#,# - Frank Thilo
* CTF flag returning to base fixes - Frank Thilo
* sort teams by score, sort in self - janne hassinen, Tim Riker
* observer hack, should be a team - Frank Thilo
* /countdown, /lagwarn - Frank Thilo
* PatchId fixes - Frank Thilo, Tim Riker
* New lag measurement using pings - Frank Thilo
* Reassign keyboard menu is now in two columns - Dave Brosius
* Fix MsgMessage and CLIENTQUERY handling - Frank Thilo
* -ban - David Trowbridge, Dave Brosius, Tim Riker
* Mac OSX work - Kevin Avila <kevin@hzsystems.com>
* -cr random ctf maps - Tim Riker, Frank Thilo
* bots in building fix - Tim Riker, Harry Dodgson
* Pause and not responding on HUD - Frank Thilo
* Message History buffer - Dave Brosius (cleaned by Tim Riker)
* Nemesis set on direct receive - Frank Thilo
* LT and RT command line aliases for shell impaired - Tim Riker
* radar shade flags by altitude - Tim Riker (reworked from Jeremiah)
* different kill msgs - Sal Gonzalez, Tim Riker
* brighter radar colors - Tim Riker with much input from others
* team colored shock wave - Tim Riker
* team colored lasers - Dave Brosius
* turn off ctf, if bases not found in world file - Dave Brosius
* patchid optimization for new clients - Dave Brosius
* udp request fix for later clients - Tim Riker
* MsgEnter should not be patched for ID - Frank Thilo
* Removed superfluous buffer copies in bzfs buffer sends - Dave Brosius
* Better pack/unpack code for vectors [3] - Dave Brosius
* Fix Teamflag drop over building when building at 0,0,0 - Dave Brosius
* Fix flags spawning in pyramids - Dave Brosius
* Fix client crashes with UNKNOWNS - Valery Fouques
* fix patchMessage for MsgAlive - Dave Brosius
* fix find closest flag (ID) with flags on buildings - Dave Brosius
* scale flags bases on elevation - Tim Riker
* don't scale radar based on screen res - Tim Riker
* flag radar updated - Tim Riker
* new admin commands - Tim Riker
* -pr for reconnect port (two port tcp) - Tim Riker


BZFlag 1.7e4 (was 1.7e3 while in development)
------------

* ::memset() instead of bzero() - Björn Augustsson
* win32 audio thread fix for win2k - crs
* send to nemesis - Dave Brosius, Frank Thilo
* USB joystick support - Nick Sayer
* new (faster?) radar jamming code - Mathias Gumz
* sort by score - Colin Bayer, Dave Brosius, Tim Riker
* world file rad -> deg - Tim Riker
* add player flag display to HUD - Tim Riker (prompted by Colin Bayer)
* random height pyramids too - Tim Riker
* dim rogue color when blind - Colin Bayer
* colorize shots on radar - Colin Bayer
* keyboard movement - Pier Donini
* win32 connect thread - Valery Fouques
* new sounds - Dave Brosius
* warnings - Dave Brosius
* safer placement - Frank Thilo
* don't color shots when CB - Valery Fouques
* jump while typing - Valery Fouques
* don't lock on paused or not responding - Valery Fouques
* -lagdrop server option - Colin Bayer
* fix team flag display - Colin Bayer
* add rogue team and radar colors to config - Valery Fouques
* Shots as lines on radar - Valery Fouques, Tim Riker
* CTF world from file - Colin Bayer, Tim Riker
* patch playerIds to prepare for one tcp port - Tim Riker
* missile sound effect - Dave Brosius
* udp first then multicast, IRIX fix? (use -i <> for multicast) - Tim Riker
* enhanced radar - Jeremiah
* don't relay read in player read - Frank Thilo, Tim Riker
* -fb flags on box buildings - Tim Riker, Colin Bayer
* networking code fixes - Tim Riker, Frank Thilo, etc.
* new admin commands - Tim Riker
* enhance SR - Tim Riker, Dave Brosius
* rotated/elevated bases - David Trowbridge, Tim Riker
* GM lock alert msg/sound - Tim Riker (prompted by Colin Bayer)


BZFlag 1.7e2
------------

* bzfs performance fix, wait loop removal - chestal/timr
* limbo flag bugfix - chestal
* *bsd cleanups from new ports maintainer - Nick Sayer
* scrollback cleanups - crs
* minimum size now 256x192 - Tim Riker
* various bug fixes - many

BZFlag 1.7e1
------------

* optional UDP unicast based networking,
  downward compatible with the old TCP method - frank
* GM now leave smoke trail - frank
* Explosions are larger - frank
* Scrollback and Line wrap (use pageup/down keys) - Digit1
* radar tank dots are larger - frank
* robots have playerxx names and player's email - Tim Riker
* colorize console messages - Tim Riker
* robots score when killing 'owner' - chestal <thilo@unix-ag.org>
* flags under high buildings - Jeremiah
* "world" section in world from file - Jeremiah
* dim paused/nr tanks on radar - chestal
* fix bzfls for servers on non-5155 - Tim Riker
* pgup/pgdn support in help menu - Kris Verbeeck
* stop using signal() as suggested by Frank Thilo - Tim Riker
* Triple buffering support (actually n way buffering) - XiGraphics
* Joystick support - XiGraphics
* teleporter shot handling improved - chestal
* udp network code reworking to select() on one server port - Tim Riker
* rogue tank placement on enter - chestal
* pseudo variable height buildings in cf mode - Tim Riker
* don't drain and flush audio on solaris - frank
* alpha Macintosh port - Darrell Walisser <dwaliss1@purdue.edu>
* quick message support - Kris Verbeeck
* /kick and /lagstats server messages, -passwd - Frank Thilo


BZFlag 1.7e release 000
-----------------------

* Tim Riker <Tim@Rikers.org> now maintainer
* build now 3 digits so alpha sorts work (until we hit 1.10? ;-)
* copyright and naming changes
* save flaghelp and score state
* FreeBSD patch by Eric Anholt
* world creation reordering to support world from file
* compilation with VC++6 Jeremiah Moss <moss-taylor@yahoo.com>
* world from a file by Daniel Léonard <fork@videotron.ca>
* travel underneath floating buildings by Jeremiah
* radar update to not hide teleporters under buildings by Jeremiah
* teleporter player positioning by Jeremiah
* bottoms on floating buildings by Jeremiah
* Windows highest refresh rate on program switch by Jeremiah
* dns lookups on list server for faster server lists
* non-blocking I/O for bzfs and name lookups by crs
* phantom player fix by Frank Siegert <frank@this.net>

BZFlag 1.7d release 9
---------------------

* fixed bug in parsing arguments in bzfls
* fixed reference counting bug in bzfls
* improved win32 config file location (Daniel Leonard)


BZFlag 1.7d release 8
---------------------

* fixed bug in bzfs that caused the player table to fill up
* fixed bugs in bzfls that left open sockets and leaked memory
* fixed bug in bzfls that could cause one server to be listed multiple times
* made bzfls more picky about format of messages
* added uptime to bzfls statistics
* changed bzfls protocol and bzfs to match
    deliberately not backwards compatible to force upgrades
* gave flag help messsages more space to avoid overlapping target box


BZFlag 1.7d release 7
---------------------

* added sym link for bzfs in RPM spec file
    can't launch server from client without it
* changed RPM naming scheme to be more standard (now named 1.7d.7)
* fixes for solaris compiler
* fixed tarball make target to include top level directory
* fixes to avoid making OpenGL calls after exiting main
* fixed mix-up between brightness and volume controls on options menu
* fixed busy wait bug in linux sound code
* incremented number of sound chunks on linux and fixed low water mark
* reduced sound latency on linux
* doubled sound volume
* fixes for linux resolution changes (now destroys/recreates OpenGL contexts)
* workaround for accelerated glx preventing screen redraw after exit
* added -3dfx and -no3dfx bzflag options to set/unset MESA_GLX_FX


BZFlag 1.7d release 6
---------------------

* now allows user to configure a non-optimized build (e.g. make linux-noopt)
* added tarball make target to gather source tree into a tarball
* modified spec file for RPM packaging (Tim Riker)
* more sound fixes
    now always writes sound even when silent (which simplifies things)
    now handles failure of SNDCTL_DSP_SETFRAGMENT
    BZF_NOAUDIO_POST env var disables latency workaround when SETFRAGMENT fails
    fixed bug that caused some truncated chunks
* video format menu now uses multiple pages if lots of formats
* now ungrabs mouse on pause and grabs on resume (if grabbing)
* players now drop a team flag when pausing (prevents a cheat)
* made some readouts more readable at low resolution (changed font)
* changes to bzfs to make it more robust against network errors
* fixed bzfs messages to bzfls (was only ever sending ADD messages)
* bzfls now keeps traffic statistics (SIGUSR2 dumps to /var/tmp/bzfls.cnt)
* added man pages for bzfls and bzfrelay


BZFlag 1.7d release 5
---------------------

* now allows user to configure a debug build (e.g. make linux-i386-debug)
* cleaned up some compiler warnings
* fixed silliness in PIXELFORMATDESCRIPTOR stuff in win32
* fixed multicasting support
* fixed sound volume bug (reset to zero in config if quit when paused)
* fixed handling of window close under X windows
* fixed several serious bugs in sound filtering
    coordinate system was totally wrong
    various calculations were incorrect
* improved sound support on linux and got sound working on linux ppc
* improved stereo panning filtering
    new transfer function does better directional attenuation
* added inter-aural delay to enhance stereo separation
* added support for brightness control (i.e. gamma correction)
    only available on PseudoColor or DirectColor visuals under X
    only available on win32 if using colormap or SetDeviceGammaRamp() works
* added custom visual choosing algorithm on X (to prefer DirectColor over True)
    making it more likely to get a gamma correctable visual
* added support for destroying/recreating OpenGL context on-the-fly
    required to support dynamic video format chaning on win32
* support for dynamic changing of video format on xfree86 and win32
    removed startup format picker on win32 -- change format through options
* improved integration with win32 desktop (alt-tab, screen saver, etc.)
    minimizes on loss of focus;  disables annoying key sequences
* config file on win32 now saved in a consistent location


BZFlag 1.7d release 4
---------------------

* changed LICENSE to the GNU GPL version 2
* server can now register itself with multiple list servers
* client can now check multiple list servers at once
* bzfls can now dump server list to a file (using USR1)
* bzfls can now bootstrap server list from a file
* now truncates descriptions that are too long;  was rejecting server
* fixed ref count bug in bzfls


BZFlag 1.7d release 3
---------------------

* fixed truncation of server list reads
* fixed menuing bug in find servers when no servers found
* -geometry is no longer ignored for 3Dfx cards
* turned off roaming and snapshoting in non-debug builds
* `-list default' now resets server list url to default
* simplified maintenance of version number
* fixed output from -version on win32
* added window border on win32 when using -window
* re-fixed bzfls query reading-freed-memory bug (regressed somehow)


BZFlag 1.7d release 2
---------------------

* fixed reading-freed-memory bug in client querying of bzfls
* replaced incorrect use of errno with getErrno()
* fixed bug in ServerLink::read();  now won't try to recv() zero bytes


BZFlag 1.7d release 1
---------------------

* starting from 1.7c release 2 patch 3
* preliminary support for bzfls, a server for listing bzfs servers
* changed win32 installer to ignore errors when changing the registry
* added extra help output when bzflag can't find font files
* fixed badly matched braces that broke multicast code


BZFlag 1.7c release 2 patch 3
-----------------------------

* fixed byte-order problem in bzfrelay (Tim Riker)
* unix portability fix:  replaced cuserid() with getuid() (Erik Andersen)
* now links mesa as GL and GLU to support non-mesa
* fixed bug in linux multicast support


BZFlag 1.7c release 2 patch 2
-----------------------------

* final solaris sound support (Andrew White)


BZFlag 1.7c release 2 patch 1
-----------------------------

* added solaris to configuration list
* preliminary sound support on Solaris (Andrew White)
* fixed 32 bit dependency;  now works on 64 bit (alpha) linux (Phillip Ezolt)
* added missing entries in irix packaging (some data files)
* added stacked stereo patch (Stea Greene)


BZFlag 1.7c release 2
---------------------

first official open source release.

* misc. changes for solaris (Bjorn Augustsson)
  * changed u_int* to uint*
  * replaced [ds]rand48() with [s]rand()
  * changed variable name `sun' with 'theSun'
  * changed ioctl FIONBIO to fcntl O_NDELAY
  * changed FNDELAY to O_NDELAY
  * glColor*() are macros;  changed code that took address of function
  * no hstrerror
  * solaris defines SIG_PF
* added unofficial solaris config (Bjorn Augustsson)
  * porting is not complete
  * not included in platform list
* made generic linux config (Phillip Ezolt)
* ifdef'd DEADLINE code for irix
* static/dynamic libaudio fix for irix
* friend class workaround for irix 7.2.1 compilers
* fixed broadcasting and multicasting on linux


BZFlag 1.7c release 1
---------------------

preliminary open source release.


